// Client_demoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Client_demo.h"
#include "Client_demoDlg.h"
#include "RegisterSettingDlg.h"

#define RIGHT_ITEM_LIST {IDC_STATIC_DEMO, \
						 IDC_COMBO_MODE, \
						 IDC_BUTTON_REGISTER_SETTING, \
						 IDC_STATIC_IMAGE_FORMAT, \
						 IDC_RADIO_QVGA, \
						 IDC_RADIO_VGA, \
						 IDFERMER}

#define BOTTOM_ITEM_LIST {IDC_STATIC_MESSAGE, \
						 IDFERMER}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClient_demoDlg dialog

CClient_demoDlg::CClient_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClient_demoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClient_demoDlg)
	m_staticMessage = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClient_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClient_demoDlg)
	DDX_Control(pDX, IDC_COMBO_MODE, m_comboMode);
	DDX_Text(pDX, IDC_STATIC_MESSAGE, m_staticMessage);
	DDV_MaxChars(pDX, m_staticMessage, K_LG_MESSAGE);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClient_demoDlg, CDialog)
	//{{AFX_MSG_MAP(CClient_demoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDFERMER, OnFermer)
	ON_CBN_SELCHANGE(IDC_COMBO_MODE, OnSelchangeComboMode)
	ON_BN_CLICKED(IDC_BUTTON_REGISTER_SETTING, OnButtonRegisterSetting)
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDC_RADIO_QVGA, OnRadioQvga)
	ON_BN_CLICKED(IDC_RADIO_VGA, OnRadioVga)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClient_demoDlg message handlers

BOOL CClient_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// ------------------------------------------------------------------------
	// Initialize Bitmap Info Header
	// ------------------------------------------------------------------------

	// Create bitmap info structures
	m_bmpInfo_vga.bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
	m_bmpInfo_vga.bmiHeader.biWidth         = K_VGA_W;
	m_bmpInfo_vga.bmiHeader.biHeight        = -K_VGA_H;	
	m_bmpInfo_vga.bmiHeader.biPlanes        = 1;
	m_bmpInfo_vga.bmiHeader.biBitCount      = 24;
	m_bmpInfo_vga.bmiHeader.biCompression   = BI_RGB;
	m_bmpInfo_vga.bmiHeader.biXPelsPerMeter = 0;
	m_bmpInfo_vga.bmiHeader.biYPelsPerMeter = 0;
	m_bmpInfo_vga.bmiHeader.biClrUsed       = 0;
	m_bmpInfo_vga.bmiHeader.biClrImportant  = 0;
	m_bmpInfo_vga.bmiHeader.biSizeImage     = 0;
	m_bmpInfo_qvga.bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
	m_bmpInfo_qvga.bmiHeader.biWidth         = K_QVGA_W;
	m_bmpInfo_qvga.bmiHeader.biHeight        = -K_QVGA_H;	
	m_bmpInfo_qvga.bmiHeader.biPlanes        = 1;
	m_bmpInfo_qvga.bmiHeader.biBitCount      = 24;
	m_bmpInfo_qvga.bmiHeader.biCompression   = BI_RGB;
	m_bmpInfo_qvga.bmiHeader.biXPelsPerMeter = 0;
	m_bmpInfo_qvga.bmiHeader.biYPelsPerMeter = 0;
	m_bmpInfo_qvga.bmiHeader.biClrUsed       = 0;
	m_bmpInfo_qvga.bmiHeader.biClrImportant  = 0;
	m_bmpInfo_qvga.bmiHeader.biSizeImage     = 0;

	ghClient_demoDlg = this->m_hWnd;

	// Initial settings
	CheckRadioButton(IDC_RADIO_QVGA, IDC_RADIO_VGA, IDC_RADIO_QVGA);
	gImageFormat = K_QVGA;

	// Activate initial mode
	m_comboMode.SetCurSel(gMode);
	OnSelchangeComboMode();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClient_demoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClient_demoDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// Image display
		BITMAPINFO *bmpInfo = NULL;
		if (gImageFormat == K_VGA) bmpInfo = &m_bmpInfo_vga;
		else if (gImageFormat == K_QVGA) bmpInfo = &m_bmpInfo_qvga;
		if (bmpInfo != NULL) SetDIBitsToDevice(
			dc.GetSafeHdc(),
			10,	// x-coordinate of upper-left corner of dest. rect
			10,	// y-coordinate of upper-left corner of dest. rect
			bmpInfo->bmiHeader.biWidth,	// source rectangle width 
			-bmpInfo->bmiHeader.biHeight,	// source rectangle height 
			0,	// x-coordinate of lower-left corner of source rect
			0,	// y-coordinate of lower-left corner of source rect
			0,	// first scan line in array 
			-bmpInfo->bmiHeader.biHeight,	// number of scan lines 
			(void*) gImage,		// address of array with DIB bits
			bmpInfo,			// address of structure with bitmap info
			DIB_RGB_COLORS);			// RGB or palette indices 
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClient_demoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClient_demoDlg::OnFermer() 
{
	CDialog::OnOK();
}

void CClient_demoDlg::OnSelchangeComboMode() 
{
	gMode = (CLIENT_DEMO_MODE) m_comboMode.GetCurSel();
	SetDlgItemText(IDC_STATIC_MESSAGE, gtMode[gMode].rq_str);
	printf("gMode = %d\n", gMode);
	sendSocket((char*) &gtMode[gMode].rq, sizeof(gtMode[gMode].rq));
}

void CClient_demoDlg::OnButtonRegisterSetting() 
{
	CRegisterSettingDlg dlg;
	dlg.DoModal();
}

void CClient_demoDlg::OnRadioQvga() 
{
	gImageFormat = K_QVGA;

	// Reduce dialog window
	GetWindowPlacement(&m_wndpl);
	m_wndpl.rcNormalPosition.left += 160;
	m_wndpl.rcNormalPosition.top += 120;
	m_wndpl.rcNormalPosition.right -= 160;
	m_wndpl.rcNormalPosition.bottom -= 120;
	SetWindowPlacement(&m_wndpl);

	// move controls
	int ii;
	int right_items[] = RIGHT_ITEM_LIST;
	int bottom_items[] = BOTTOM_ITEM_LIST;
	WINDOWPLACEMENT wndpl;
	for (ii=0; ii<sizeof(right_items)/sizeof(right_items[0]); ii++)
	{
		GetDlgItem(right_items[ii])->GetWindowPlacement(&wndpl);
		wndpl.rcNormalPosition.left -= 320;
		wndpl.rcNormalPosition.right -= 320;
		GetDlgItem(right_items[ii])->SetWindowPlacement(&wndpl);
	}
	for (ii=0; ii<sizeof(bottom_items)/sizeof(bottom_items[0]); ii++)
	{
		GetDlgItem(bottom_items[ii])->GetWindowPlacement(&wndpl);
		wndpl.rcNormalPosition.top -= 240;
		wndpl.rcNormalPosition.bottom -= 240;
		GetDlgItem(bottom_items[ii])->SetWindowPlacement(&wndpl);
	}
	int rq = MD_RQ_FORMAT_QVGA;
	sendSocket((char*) &rq, sizeof(rq));

	Invalidate();
	UpdateWindow();
}

void CClient_demoDlg::OnRadioVga() 
{
	gImageFormat = K_VGA;

	// Expand dialog window
	GetWindowPlacement(&m_wndpl);
	m_wndpl.rcNormalPosition.left -= 160;
	m_wndpl.rcNormalPosition.top -= 120;
	m_wndpl.rcNormalPosition.right += 160;
	m_wndpl.rcNormalPosition.bottom += 120;
	SetWindowPlacement(&m_wndpl);

	// move controls
	int ii;
	int right_items[] = RIGHT_ITEM_LIST;
	int bottom_items[] = BOTTOM_ITEM_LIST;
	WINDOWPLACEMENT wndpl;
	for (ii=0; ii<sizeof(right_items)/sizeof(right_items[0]); ii++)
	{
		GetDlgItem(right_items[ii])->GetWindowPlacement(&wndpl);
		wndpl.rcNormalPosition.left += 320;
		wndpl.rcNormalPosition.right += 320;
		GetDlgItem(right_items[ii])->SetWindowPlacement(&wndpl);
	}
	for (ii=0; ii<sizeof(bottom_items)/sizeof(bottom_items[0]); ii++)
	{
		GetDlgItem(bottom_items[ii])->GetWindowPlacement(&wndpl);
		wndpl.rcNormalPosition.top += 240;
		wndpl.rcNormalPosition.bottom += 240;
		GetDlgItem(bottom_items[ii])->SetWindowPlacement(&wndpl);
	}
	int rq = MD_RQ_FORMAT_VGA;
	sendSocket((char*) &rq, sizeof(rq));
}
