#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#define TS_DEV_NAME "/dev/input/touchscreen0"

struct ts_event {
  unsigned short	pressure;
  unsigned short	x;
  unsigned short	y;
  unsigned short	pad;
  struct timeval	stamp;
};

int main(int argc, char *argv[])
{
  int ts_dev, ii;
  struct ts_event ts_data;

  printf("\n\n   ***   test_ts   ***\n\n");
  printf("Basic test for UCB1400 touchscreen driver.\n\n");

  ts_dev = open(TS_DEV_NAME, O_RDWR);
  if (ts_dev < 0) {
    perror("open");
    exit(1);
  }
  else {
    printf("%s open succeeded.\n", TS_DEV_NAME);
    sleep(5);
/*     for (ii=0; ii<100; ii++) { */
/*       sleep(1); */
/*       if (read(ts_dev, (void*) &ts_data, sizeof(ts_data)) < 0) { */
/* 	perror("read touchscreen"); */
/* 	break; */
/*       } */
/*       else */
/* 	printf("x=%hu y=%hu p=%hu\n", ts_data.x, ts_data.y, ts_data.pressure); */
/*     } */
    close(ts_dev);
  }
}
