/***************************************************/
/*                                                 */
/*  COMMON DECLARATIONS FOR MBS270 DEMO SOFTWARE   */
/*                                                 */
/*  Copyright Mobisense Systems 2007               */
/*                                                 */
/***************************************************/

#ifndef _MBS270_DEMO_H_
#define _MBS270_DEMO_H_

#define MD_SOCKET_PORT	4444

typedef enum {
  MD_MSG_INITDATA, \
  MD_MSG_STRING, \
  MD_MSG_IMG_Y8, \
  MD_MSG_IMG_YCRCB422_PK, \
  MD_MSG_IMG_YCRCB422_PL, \
  MD_MSG_IMG_RAW_RGB_PL, \
  MD_MSG_IMG_GRAD_H, \
  MD_MSG_IMG_GRAD_V, \
  MD_MSG_IMG_EDGE, \
  MD_MSG_REG_VAL, \
  MD_MSG_MAX} mcd_msg_t;

typedef enum {
  MD_RQ_QUIT, \
  MD_RQ_STDBY, \
  MD_RQ_IMG_Y8, \
  MD_RQ_IMG_YCRCB422_PK, \
  MD_RQ_IMG_YCRCB422_PL, \
  MD_RQ_IMG_RAW_RGB_PL, \
  MD_RQ_IMG_GRAD_H, \
  MD_RQ_IMG_GRAD_V, \
  MD_RQ_IMG_EDGE, \
  MD_RQ_GET_REG_VAL, \
  MD_RQ_SET_REG_VAL, \
  MD_RQ_FORMAT_VGA, \
  MD_RQ_FORMAT_QVGA, \
  MD_RQ_MAX} mcd_rq_t;

/* header of exchanged messages */
typedef struct _md_msghdr_ {
  int type;		/* message type, MD_MSG_*** or MCD_RQ_*** */
  int bodylen;	/* length of message body */
} md_msghdr_t;

#endif /* _MBS270_DEMO_H_ */



